
program ECHECS; {&PmType Pm}

uses
  WinTypes, WinProcs, OWindows, Strings, Moteur;

type
  tTablier = array[-10..109] of longInt;

const
  valeurNeant    =   0;
  valeurPion     =   2;
  valeurFou      =   6;
  valeurCavalier =   7;
  valeurTour     =  10;
  valeurRoi      = 126;
  valeurDame     =  19; 
  noir           =  -1;
  blanc          =   1;

{$I Texte.inc}
{$I Couleurs.inc}
{$I Bouton.inc}
{$I Damier.inc}

var
  userInput: string[4] = '';
  
type
  pChssBrdWnd = ^tChssBrdWnd;
  
  tChssBrdWnd = object(tWindow)
   {ChssFont: hFont;}
    constructor Init(p: pWindowsObject; aName: pChar);
    procedure SetUpWindow;
    virtual;
    procedure GetWindowClass(var aWndClass: tWndClass);
    virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: tPaintStruct);
    virtual;
    procedure WMLButtonDown(var msg: tMessage);
    virtual wm_First + wm_LButtonDown;
    destructor Done;
    virtual;
  end;

  tChssPrg = object(TApplication)
    procedure InitMainWindow; virtual;
  end;
  
constructor tChssBrdWnd.Init(p: pWindowsObject; aName: PChar);
begin
  inherited Init(p, aName);
  Attr.Style := WS_VISIBLE or WS_POPUP;
  Attr.X := (GetSystemMetrics(SM_CXFULLSCREEN)-480) div 2;
  Attr.Y := (GetSystemMetrics(SM_CYFULLSCREEN)-480) div 2;
  Attr.W := 480;
  Attr.H := 480;
  DisposeBoutons;
 {ChssFont := CreateFont(40, 0,0,0,
                         FW_LIGHT, 0,0,0,
                         DEFAULT_CHARSET, 0,0,0,0,
                         'Chess Alpha');}
  Moteur.initialisation;
end;

procedure tChssBrdWnd.SetUpWindow;
begin
  inherited SetUpWindow;
end;

procedure tChssBrdWnd.GetWindowClass(var aWndClass: tWndClass);
begin
  tWindow.GetWindowClass(AWndClass);
  aWndClass.hbrBackground := CreateSolidBrush(Lavender);
end;

procedure DrawCloseButton;
var 
  DC: hDC; 
  x, y: integer;
begin 
  DC := GetDC(Application^.MainWindow^.HWindow);
  for y := 0 to 31 do for x := 0 to 31 do
  if CloseButton[y, x] = 0 then SetPixel(DC,
                                         x + 448 - 8,
                                         y + 8,
                                         PrussianBlue)
                           else SetPixel(DC,
                                         x + 448 - 8,
                                         y + 8,
                                         Lavender); 
end;

procedure tChssBrdWnd.Paint(PaintDC: HDC;
                     var PaintInfo: TPaintStruct);
var
  S: array[0..255] of Char;
  ChssFont, OldFont: hFont;
  i, j: longInt;
  R: tRect;
  TablierCourant: tTablier;
begin
  DrawCloseButton;
  SetBkColor(PaintDC, Lavender);
  SetTextColor(PaintDC, PrussianBlue);
  ChssFont := CreateFont(40, 0,0,0,
                         FW_LIGHT, 0,0,0,
                         DEFAULT_CHARSET, 0,0,0,0,
                         'Chess Alpha');
  OldFont := SelectObject(PaintDC, ChssFont);
  
  for i := -10 to 109 do
    TablierCourant[i] := Moteur.courante.tablier[i];
  
  StrCopy(S, #0);
  for j := 9 downTo 0 do
  begin
    for i := 0 to 9 do
      StrCat(S, @Chr(TexteCourant(TablierCourant, True)[i, j]));
    StrCat(S, #13#10);
  end;
  
  GetClientRect(hWindow, R);
  Inc(R.left, 40); Inc(R.top, 40);
  DrawText(PaintDC, S, StrLen(s), R, DT_LEFT);
  
  DeleteObject(SelectObject(PaintDC, OldFont));
end;

destructor tChssBrdWnd.Done;
begin
  tWindow.Done;
end;

procedure tChssBrdWnd.WMLButtonDown(var msg: TMessage);
var
  c: longInt;
  s: array[0..255] of char;
begin
  clicXs := LoWord(msg.lParam);
  clicYs := HiWord(msg.lParam);
  clic := true;
  c := GetClick(Boutons);
  if c = 64 then
    CloseWindow;
  if Length(userInput) = 0 then
    userInput := userInput + StrCoord(c)
  else
    begin
      userInput := userInput + StrCoord(c);
     {StrPCopy(s, userInput);
      MessageBox(0, s, 'Test', mb_Ok);}
      if Moteur.entreeUtilisateur(userInput) then
      // i.e. si le coup saisi est un coup légal
      // auquel cas la fonction accomplit le coup
        begin
        //
        InvalidateRect(hWindow, nil, true); // à améliorer
        //
        Moteur.coupOrdinateur;
        //
        if EtatPartie <> EnCours then
        begin
          case EtatPartie of
            BlancGagnant:;
            NoirGagnant:;
            Pat:;
          end;
        end;
        //
        InvalidateRect(hWindow, nil, true); // à améliorer
        //
        end
      else
        begin
          MessageBox(0, 'Ce coup n''est pas l'#233'gal.', 'Test', mb_Ok);
        end;
      userInput := '';
    end;
end;

procedure tChssPrg.InitMainWindow;
begin
  MainWindow := New(pChssBrdWnd, Init(nil, 'ChessProgram'));
end;

var
  ChssPrg: tChssPrg;

begin
  ChssPrg.Init('ChessProgram');
  ChssPrg.Run;
  ChssPrg.Done;
end.
