
unit Moteur;


interface

procedure initialisation;
function entreeUtilisateur(s: string): boolean;
procedure coupOrdinateur;

type
  tPosition = record
    tablier: array[-10..109] of longint;
    carreauPassant: array[-1..1] of longint;
    listeCoupsProvenance: array[1..100] of longint;
    listeCoupsDestination: array[1..100] of longint;
    listeCoupsValeur: array[1..100] of longint;
    compteur, materiel, couleur: longint;
  end;
  
var
  courante, initiale: tPosition;
  valeur, nombreAdmissibles: longint;
  admissiblesProv: array[1..100] of longint;
  admissiblesDest: array[1..100] of longint;
  admissiblesNote: array[1..100] of longint;
  histoireProvenance: array[1..700] of longint;
  histoireDestination: array[1..700] of longint;
  
type
  tEtatPartie = (EnCours, BlancGagnant, NoirGagnant, Pat); 

var
  EtatPartie: tEtatPartie;


implementation

var
  demiCoups: longint = 0;
  profondeur: longint;
  profondeurMax: longint;

const
  valeurNeant = 0;
  valeurPion = 2;
  valeurFou = 6;
  valeurCavalier = 7;
  valeurTour = 10;
  valeurRoi = 126;
  valeurDame =  19;
  horsJeu = 127;

  pion: array[1..4] of longint = (1, 2, -9, 11);
  cavalier: array[1..8] of longint = (12, 21, 19, 8, -12, -21, -19, -8);
  fou: array[1..4] of longint = (11, -11, 9, -9);
  tour: array[1..4] of longint = (-1, 1, -10, 10);
  roi: array[1..8] of longint = (-1, 1, -10, 10, 11, -11, 9, -9);

  noir = -1;
  blanc = 1;

function valeurPosition(const p: tPosition; couleur: longint): longint;
  begin
    valeurPosition := p.materiel * couleur;
  end;

procedure initialisation;
  var i, j: longint;
  begin
    with initiale do
    begin
      for i := -9 to 110 do tablier[i] := horsJeu;
      for i := 1 to 8 do for j := 1 to 8 do tablier[i * 10 + j] := valeurNeant;
      tablier[18] := noir * valeurTour;
      tablier[28] := noir * valeurCavalier;
      tablier[38] := noir * valeurFou;
      tablier[48] := noir * valeurDame;
      tablier[58] := noir * valeurRoi;
      tablier[68] := noir * valeurFou;
      tablier[78] := noir * valeurCavalier;
      tablier[88] := noir * valeurTour;
      for i := 1 to 8 do tablier[i * 10 + 7] := noir * valeurPion;
      for i := 1 to 8 do tablier[i * 10 + 2] := blanc * valeurPion;
      tablier[11] := blanc * valeurTour;
      tablier[21] := blanc * valeurCavalier;
      tablier[31] := blanc * valeurFou;
      tablier[41] := blanc * valeurDame;
      tablier[51] := blanc * valeurRoi;
      tablier[61] := blanc * valeurFou;
      tablier[71] := blanc * valeurCavalier;
      tablier[81] := blanc * valeurTour;
      couleur := blanc;
    end;
    courante := initiale;
    EtatPartie := EnCours;
  end;

procedure representation;
  begin
  end;

procedure mouvement (var courante: tPosition; A, B: longint);
  begin
    with courante do
    begin

      if (abs(B - A) = 2) and (abs(tablier[A]) = valeurPion)
      then carreauPassant[couleur] := A + pion[1] * couleur
      else carreauPassant[couleur] := 0;

      if (B = carreauPassant[-1 * couleur])
      and (tablier[A] = valeurPion * couleur) then
        begin
          carreauPassant[couleur] := 0; // ?
          mouvement(courante, A, (B div 10) * 10 + A mod 10); // ?
          couleur := -1 * couleur;
          A := (B div 10) * 10 + A mod 10; // ?
        end;

      if (A in [51, 58]) and (B in [71, 31, 78, 38])
      and (abs(tablier[A]) = valeurRoi) then
        begin
          tablier[B] := tablier[A];
          tablier[A] := 0;
          if B div 10 = 7 then
            begin
              A := (A mod 10) + 80;
              B := A - 20;
            end
          else
            begin
              A := (A mod 10) + 10;
              B := A + 30;
            end;
          tablier[B] := tablier[A];
          tablier[A] := 0;
        end
      else
        begin
          materiel := materiel - tablier[B];
          tablier[B] := tablier[A];
          tablier[A] := 0;
          if (B mod 10 = 1) or (B mod 10 = 8) then
            if abs(tablier[B]) = valeurPion then
              begin
                tablier[B] := valeurDame * couleur;
                materiel := materiel + (valeurDame - valeurPion) * couleur;
              end;
        end;
      couleur := -1 * couleur;
    end;
  end;

procedure enregistrement (var courante: tPosition; const A, B: longint);
  begin
    with courante do
    begin
      if abs(materiel) > 83 then exit; //  ?
      inc(compteur);
      listeCoupsProvenance[compteur] := A;
      listeCoupsDestination[compteur] := B;
    end;
  end;

procedure generateur1 (var courante: tPosition);
  var
    A, B: longint;
    i, j, k, l: longint;
  begin
    with courante do
    begin
      compteur := 0;
      for j := 1 to 8 do
        for k := 1 to 8 do
        begin
          A := j * 10 + k;
          if tablier[A] <> valeurNeant then
          begin
            case tablier[A] * couleur of

              valeurPion:
                begin
                  B := A + pion[1] * couleur;
                  if tablier[B] = valeurNeant then
                  begin
                    enregistrement(courante, A, B);
                    if (couleur = blanc) and (k = 2)
                    or (couleur = noir) and (k = 7) then
                    begin
                      B := A + pion[2] * couleur;
                      if (tablier[B] = valeurNeant) then
                      begin
                        enregistrement(courante, A, B);
                      end;
                    end;
                  end;
                  for i := 3 to 4 do
                  begin
                    B := A + pion[i] * couleur ;
                    if (-1 * tablier[B] * couleur in [valeurPion..valeurRoi])
                    or (B = carreauPassant[-1 * couleur])
                    then enregistrement(courante, A, B);
                  end;
                end;

              valeurCavalier:
                begin
                  for i := 1 to 8 do
                    begin
                      B := A + cavalier[i];
                      if -1 * tablier[B] * couleur
                      in [valeurNeant..valeurRoi]
                      then enregistrement(courante, A, B);
                    end;
                  end;

              valeurFou:
                begin
                  for i := 1 to 4 do
                    begin
                      B := A;
                      repeat
                        inc(B, fou[i]);
                        if -1 * tablier[B] * couleur
                        in [valeurNeant..valeurRoi]
                        then enregistrement(courante, A, B);
                      until tablier[B] <> valeurNeant;
                    end;
                end;

              valeurTour:
                begin
                  for i := 1 to 4 do
                    begin
                      B := A;
                      repeat
                        inc(B, tour[i]);
                        if -1 * tablier[B] * couleur in [valeurNeant..valeurRoi]
                        then enregistrement(courante, A, B);
                      until tablier[B] <> valeurNeant;
                    end;
                end;

              valeurRoi:
                begin
                  for i := 1 to 8 do
                    begin
                      B := A + roi[i];
                      if -1 * tablier[B] * couleur
                      in [valeurNeant..valeurRoi]
                      then
                      begin
                        l := 0;
                        repeat
                          inc(l);
                        until (-1 * tablier[B + roi[l]] * couleur = valeurRoi)
                        or (l = 8);
                        if l = 8 then enregistrement(courante, A, B);
                      end;
                    end;
                end;

              valeurDame:
                begin
                  for i := 1 to 8 do
                  begin
                    B := A;
                    repeat
                      inc(B, roi[i]);
                      if -1 * tablier[B] * couleur in [0..126]
                      then enregistrement(courante, A, B);
                    until tablier[B] <> 0;
                  end;
                end;
            end;
          end;
        end;
    end;
  end;

function echec (var courante: tPosition): boolean;
  var i: longint;
  begin
    with courante do
    begin
      couleur := -1 * couleur;
      generateur1(courante);
      couleur := -1 * couleur;
      echec := false;
      for i := 1 to compteur do
      begin
        if abs(tablier[listeCoupsDestination[i]]) = valeurRoi then echec := true;
      end;
    end;
  end;

procedure generateur2 (var courante :tPosition);

  procedure examenRoque (A: longint; step: longint; carreauTour: longint);
    var
      p: tPosition;
      i: longint;
    begin
      with courante do
      begin
        if tablier[carreauTour] * couleur <> valeurTour then exit;
        i := A + step;
        repeat
          if tablier[i] <> valeurNeant then exit;
          inc(i, step);
        until i = carreauTour;
        p := courante;
        if not echec(p)
        then enregistrement(courante, A, A + 2 * step);
      end;
    end;

    begin
      generateur1(courante);
      with courante do
      begin
        if tablier[51] * couleur = valeurRoi then
          begin
            examenRoque(51, 10, 81);
            examenRoque(51, -10, 11);
          end
        else
          if tablier[58] * couleur = valeurRoi then
          begin
            examenRoque(58, 10, 88);
            examenRoque(58, -10, 18);
          end;
      end;
    end;

function evalMax (var aPosition: tPosition; couleur, prof, alpha: longint): longint;
  var
    minmax, eval, numeroCoup: longint;
    p: tPosition;
    beta: longint;
    interrupteur: boolean;
  begin
    generateur2(aPosition);
    
    if aPosition.compteur = 0 then
    begin
      if echec(aPosition) then
        EtatPartie := BlancGagnant
      else
        EtatPartie := Pat;
      Exit;
    end;
    
    numeroCoup := 0;
    beta := -32000 * aPosition.couleur * couleur;
    interrupteur := false;
    while (numeroCoup < aPosition.compteur) and not (interrupteur) do
    begin
      inc(numeroCoup);
      p := aPosition;
      with aPosition
      do mouvement(p,
                   listeCoupsProvenance[numeroCoup],
                   listeCoupsDestination[numeroCoup]);
      if ((prof >= profondeur)
      and (aPosition.tablier[aPosition.listeCoupsDestination[numeroCoup]] = 0))
      or (prof = profondeurMax)
      then
        begin
          eval := valeurPosition(p, couleur);
        end
      else
        begin
          eval := evalMax(p, couleur, prof + 1, beta);
        end;
      if aPosition.couleur = couleur then
        begin
          if eval > beta then beta := eval;
          if beta > alpha then interrupteur := true;
        end
      else
        begin
          if eval < beta then beta := eval;
          if beta < alpha then interrupteur := true;
        end;
      aPosition.listeCoupsValeur[numeroCoup] := eval;
    end;
    evalMax := beta;
  end;

function entreeUtilisateur(s: string): boolean;
  var
    i: longint;
    p: tPosition;
    coup, code: longint;
    A, B: longint;
  begin
    
    code := 1;
    
    while code <> 0 do
    begin
      entreeUtilisateur := true;
      s[1] := upcase(s[1]);
      s[3] := upcase(s[3]);
      if (s[1] in ['A'..'H']) and (s[3] in ['A'..'H']) then
      begin
        s[1] := chr(ord(s[1]) - 16);
        s[3] := chr(ord(s[3]) - 16);
      end;
      val(s, coup, code);
    end;
    
    A := coup div 100;
    B := coup mod 100;

    generateur2(courante);
    
    code := 0;
    
    with courante do
    begin
      for i := 1 to compteur do
        if coup = listeCoupsProvenance[i] * 100 + listeCoupsDestination[i] then
          code := 1;
    end;

    if code = 0 then
    begin
      entreeUtilisateur := false;
      Exit;
    end;

    p := courante;
    mouvement(p, A, B);
    p.couleur := -1 * p.couleur;
    
    if echec(p) then
    begin
      entreeUtilisateur := false;
      Exit;
    end;
    
    mouvement(courante, A, B);
    inc(demiCoups);
    histoireProvenance[demiCoups] := A;
    histoireDestination[demiCoups] := B;
  end;

procedure coupOrdinateur;

  var i, j: longint;

  procedure afficheCoup(A, B: longint);
  var
    coupStr: string[4];
    coupInt: longint;
  begin
    coupInt := A * 100 + B;
    str(coupInt, coupStr);
    coupStr[1] := chr(ord(coupStr[1]) + 16);
    coupStr[3] := chr(ord(coupStr[3]) + 16);
   {write(coupStr);}
  end;

  function carreau_dans_son_etat_initial
  (var courante: tPosition; numeroCarreau: longint): boolean;
  begin
    if courante.tablier[numeroCarreau] = initiale.tablier[numeroCarreau]
    then carreau_dans_son_etat_initial := true
    else carreau_dans_son_etat_initial := false;
  end;

  function meilleurCoup: longint;
    var
      p: tPosition;
      i, j: longint;
      meilleureNote: longint;
    begin
    with courante do
      begin
        nombreAdmissibles := 0;
        for i := 1 to compteur do
        begin
          if listeCoupsValeur[i] = valeur then
          begin
            inc(nombreAdmissibles);
            admissiblesProv[nombreAdmissibles] := listeCoupsProvenance[i];
            admissiblesDest[nombreAdmissibles] := listeCoupsDestination[i];
            admissiblesNote[nombreAdmissibles] := 0;
          end;
        end;
      end;
      meilleureNote := 0;
      meilleurCoup := 1;
      for i := 1 to nombreAdmissibles do
      begin
        p := courante;
        admissiblesNote[i] := 0;
        with p do
        begin
          if carreau_dans_son_etat_initial(p, admissiblesProv[i]) then
          begin
            inc(admissiblesNote[i], 5);
            if abs(tablier[admissiblesProv[i]]) = valeurPion then inc(admissiblesNote[i], 2);
          end;

          if (abs(tablier[admissiblesProv[i]]) = valeurRoi) then dec(admissiblesNote[i], 10);

          if (demiCoups < 32)
          and (abs(tablier[admissiblesProv[i]]) in [valeurPion, valeurFou, valeurCavalier])
          then inc(admissiblesNote[i], 20);

          if (admissiblesProv[i] div 10 = 1) or (admissiblesProv[i] div 10 = 8)
          or (admissiblesProv[i] mod 10 = 1) or (admissiblesProv[i] mod 10 = 8)
          then inc(admissiblesNote[i], 2);

          if (admissiblesDest[i] div 10 = 1) or (admissiblesDest[i] div 10 = 8)
          or (admissiblesDest[i] mod 10 = 1) or (admissiblesDest[i] mod 10 = 8)
          then dec(admissiblesNote[i], 2);
        end;

        p := courante;
        mouvement(p, admissiblesProv[i], admissiblesDest[i]);

        if carreau_dans_son_etat_initial(p, admissiblesDest[i])
        then dec(admissiblesNote[i], 10);

        p.couleur := -1 * p.couleur;

        generateur1(p);

        with p do
        begin
          for j := 1 to compteur do
          begin
            inc(admissiblesNote[i]);
            if listeCoupsDestination[j] <> 0 then
            begin
              inc(admissiblesNote[i]);
            end;
          end;
        end;

        p.couleur := -1 * p.couleur;

        generateur1(p);

        with p do
        begin
          for j:=1 to compteur do
          begin
            dec(admissiblesNote[i]);
            if listeCoupsDestination[j] <> 0 then
            begin
              dec(admissiblesNote[i]);
            end;
          end;
        end;

        if admissiblesNote[i] >= meilleureNote then
        begin
          meilleureNote := admissiblesNote[i];
          meilleurCoup := i;
        end;
      end;
    end;

  var deja_en_echec: boolean;

  begin
    profondeur := 3;
    profondeurMax := 5;
    //
    valeur := evalMax(courante, courante.couleur, 1, 32000);
   {if EtatPartie <> EnCours then
      Exit;}
    //
    i := meilleurCoup;
    //
    inc(demiCoups);
    //
    histoireProvenance[demiCoups] := admissiblesProv[i];
    histoireDestination[demiCoups] := admissiblesDest[i];
    //
    deja_en_echec := echec(courante);
    //
    mouvement(courante, admissiblesProv[i], admissiblesDest[i]);
    //
    generateur2(courante);
    //
    if courante.compteur = 0 then
      if echec(courante) then
        EtatPartie := NoirGagnant
      else
        EtatPartie := Pat;
    //
  end;

end.
